Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## jif.types.label
Interface Policy

All Superinterfaces:
  java.lang.Cloneable, polyglot.util.Copy, java.io.Serializable, polyglot.types.TypeObject

All Known Subinterfaces:
  ConfPolicy, IntegPolicy, ReaderPolicy, WriterPolicy

All Known Implementing Classes:
  ConfProjectionPolicy_c, IntegProjectionPolicy_c, JoinConfPolicy_c, JoinIntegPolicy_c, JoinPolicy_c, MeetConfPolicy_c, MeetIntegPolicy_c, MeetPolicy_c, Policy_c, ReaderPolicy_c, WriterPolicy_c

    public interface Policy

extends polyglot.types.TypeObject

This class is the common super class for integrity polices and confidentiality policies.

Method Summary
`boolean` | `hasVariables()`
`boolean` | `hasWritersToReaders()`
`boolean` | `isBottom()`
`boolean` | `isCanonical()`
`boolean` | `isRuntimeRepresentable()`
`boolean` | `isSingleton()`
`boolean` | `isTop()`
`PathMap` | `labelCheck(JifContext A, LabelChecker lc)`
`Policy` | `simplify()`
`Policy` | `subst(LabelSubstitution substitution)`
`java.util.List` | `throwTypes(polyglot.types.TypeSystem ts)`
`java.lang.String` | `toString(java.util.Set printedLabels)`

Methods inherited from interface polyglot.types.TypeObject
`equalsImpl, position, typeSystem`

Methods inherited from interface polyglot.util.Copy
`copy`

Method Detail

### isCanonical

    boolean isCanonical()

  Specified by:
    `isCanonical` in interface `polyglot.types.TypeObject`

### isSingleton

    boolean isSingleton()

### isRuntimeRepresentable

    boolean isRuntimeRepresentable()

### isTop

    boolean isTop()

### isBottom

    boolean isBottom()

### hasVariables

    boolean hasVariables()

### hasWritersToReaders

    boolean hasWritersToReaders()

### throwTypes

    java.util.List throwTypes(polyglot.types.TypeSystem ts)

### subst

    Policy subst(LabelSubstitution substitution)
                 throws polyglot.types.SemanticException

  Throws:
    `polyglot.types.SemanticException`

### simplify

    Policy simplify()

### toString

    java.lang.String toString(java.util.Set printedLabels)

### labelCheck

    PathMap labelCheck(JifContext A,
                       LabelChecker lc)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD